#!/usr/bin/env python

import yaml
import textwrap

wrapper = textwrap.TextWrapper(break_long_words=False, replace_whitespace=False)

def validate_encounter(encounter):
    run_encounter(encounter)

def run_encounter(encounter):
    if 'scenario' in encounter:
        print(wrapper.fill(text=encounter['scenario']))
    if 'choices' in encounter:
        for choice in range(len(encounter['choices'])):
            print(wrapper.fill(text=f"{choice}. {encounter['choices'][choice]}"))
        playerChoice = int(input("> "))
        if playerChoice >= 0 and playerChoice <= 9:
            if encounter['choices'][playerChoice] == "Exit game":
                exit()
            else:
                validate_encounter(game[encounter['choices'][playerChoice]])
    elif "goto" in encounter:
        validate_encounter(game[encounter['goto']])

if __name__ == '__main__':
    with open("game.yaml", "r") as file:
        game = yaml.safe_load(file)
    validate_encounter(game['entrypoint'])
